package com.huimv.eartag.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.eartag.entity.BizFirstInspecEartag;
import com.huimv.eartag.entity.BizInspectionPhoto;
import com.huimv.eartag.entity.BizSellPigApply;
import com.huimv.eartag.entity.EartagRegisterEntity;
import com.huimv.eartag.mapper.BizFirstInspecEartagMapper;
import com.huimv.eartag.mapper.BizInspectionPhotoMapper;
import com.huimv.eartag.mapper.BizSellPigApplyMapper;
import com.huimv.eartag.mapper.EartagRegisterMapper;
import com.huimv.eartag.service.EartagRegisterService;
import com.huimv.eartag.service.IBizInspectionPhotoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.eartag.utils.UpImage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author astupidcoder
 * @since 2022-03-03
 */
@Service
public class BizInspectionPhotoServiceImpl extends ServiceImpl<BizInspectionPhotoMapper, BizInspectionPhoto> implements IBizInspectionPhotoService {

   private static final String PICURL = "/opt/goldpig-huimv/img";

   @Autowired
    private BizInspectionPhotoMapper bizInspectionPhotoMapper;


    @Autowired
    private BizFirstInspecEartagMapper bizFirstInspecEartagMapper;

    @Autowired
    private BizSellPigApplyMapper bizSellPigApplyMapper;

    @Autowired
    private EartagRegisterMapper eartagRegisterMapper;

    @Override
    @Transactional
    public Result addInspection(HttpServletRequest request, MultipartFile[] files, String farmId,String batchNo,String eartagNos,Integer inspecStatus) {

        DateTime date = DateUtil.date();
        //图片存储
        List<BizInspectionPhoto> bizInspectionPhotos = new ArrayList<>();
        String s = UpImage.uploadImgs(files, PICURL, request);
        String[] imgUrls = s.split(",");
        for (String imgUrl : imgUrls) {
            BizInspectionPhoto bizInspectionPhoto = new BizInspectionPhoto();
            bizInspectionPhoto.setPhotoName(imgUrl.substring(imgUrl.lastIndexOf("/")));
            bizInspectionPhoto.setBatchNo(batchNo);
            bizInspectionPhoto.setPhotoPath(imgUrl);
            bizInspectionPhoto.setPhotoType(1);

            bizInspectionPhotos.add(bizInspectionPhoto);
        }
        this.saveBatch(bizInspectionPhotos);

        //检疫明细

        String[] eartagNo = eartagNos.split(",");
        for (String eartag : eartagNo) {
            BizFirstInspecEartag bizFirstInspecEartag = new BizFirstInspecEartag();
            bizFirstInspecEartag.setBatchNo(batchNo);
            bizFirstInspecEartag.setCreateTime(date);
            bizFirstInspecEartag.setEarmark(eartag);
            bizFirstInspecEartag.setFarmId(farmId);
            bizFirstInspecEartagMapper.insert(bizFirstInspecEartag);
        }

        //修改卖猪记录状态
        BizSellPigApply bizSellPigApply = bizSellPigApplyMapper.selectOne(new QueryWrapper<BizSellPigApply>().eq("batch_no", batchNo));
        bizSellPigApply.setInspecFlowStatus(1);
        bizSellPigApply.setInspecTime(date);
        if (inspecStatus == 0){
            bizSellPigApply.setRecordStatus(4);
        }
        bizSellPigApplyMapper.updateById(bizSellPigApply);

        //修改耳标注册记录状态
        EartagRegisterEntity eartagRegisterEntity =new EartagRegisterEntity();
        eartagRegisterEntity.setStage(12);
        UpdateWrapper<EartagRegisterEntity> updateWrapper =new UpdateWrapper<>();
        updateWrapper.in("eartag_no", eartagNo);
        eartagRegisterMapper.update(eartagRegisterEntity,updateWrapper);


        return new Result(ResultCode.SUCCESS,"上传");
    }
}
